<?xml version="1.0" encoding="UTF-8"?>
<!--
 * Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
 * Copyright (C) 2008 - INRIA
 * 
 * This file must be used under the terms of the CeCILL.
 * This source file is licensed as described in the file COPYING, which
 * you should have received as part of this distribution.  The terms
 * are also available at    
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
 *
 -->
<refentry version="5.0-subset Scilab" xml:id="lex_sort" xml:lang="en"
          xmlns="http://docbook.org/ns/docbook"
          xmlns:xlink="http://www.w3.org/1999/xlink"
          xmlns:svg="http://www.w3.org/2000/svg"
          xmlns:ns5="http://www.w3.org/1999/xhtml"
          xmlns:mml="http://www.w3.org/1998/Math/MathML"
          xmlns:db="http://docbook.org/ns/docbook">
  <info>
    <pubdate>$LastChangedDate$</pubdate>
  </info>

  <refnamediv>
    <refname>lex_sort</refname>

    <refpurpose>lexicographic matrix rows sorting</refpurpose>
  </refnamediv>

  <refsynopsisdiv>
    <title>Calling Sequence</title>

    <synopsis>[N, [k]]=lex_sort(M [,sel] [,'unique'])
</synopsis>
  </refsynopsisdiv>

  <refsection>
    <title>Parameters</title>

    <variablelist>
      <varlistentry>
        <term>M</term>

        <listitem>
          <para>real matrix</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>N</term>

        <listitem>
          <para>real matrix</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>k</term>

        <listitem>
          <para>column vector of integers</para>
        </listitem>
      </varlistentry>
    </variablelist>
  </refsection>

  <refsection>
    <title>Description</title>

    <para>the <literal>lex_sort</literal> function is now obsolete. It can be
    replaced by functions <link linkend="gsort">gsort</link> and <link
    linkend="unique">unique</link>.</para>

    <para><literal>N=lex_sort(M)</literal> sorts the rows (as a group) of the
    matrix <literal>M</literal> in ascending order. If required the output
    argument <literal>k</literal> contains the ordering:
    <literal>[N,k]=lex_sort(M)</literal> returns <literal>k</literal> such as
    <literal>N</literal> is uequal to <literal>M(k,:)</literal> .</para>

    <para><literal>N=lex_sort(M,sel [,'unique'])</literal> produces the same
    result as the following sequence of instructions:</para>

    <programlisting role = ""><![CDATA[ 
[N,k]=lex_sort(M(:,sel) [,'unique']);
N=M(k,:)
 ]]></programlisting>

    <para>The <literal>'unique'</literal> flag has to be given if one wants to
    retain only unique rows in the result. Note that
    <literal>lex_sort(M,sel,'unique')</literal> retains only rows such that
    M(:,sel) are unique.</para>
  </refsection>

  <refsection>
    <title>Examples</title>

    <programlisting role="example"><![CDATA[ 
M=round(2*rand(20,3));

lex_sort(M)
lex_sort(M,'unique')
[N,k]=lex_sort(M,[1 3],'unique')
 ]]></programlisting>
  </refsection>

  <refsection>
    <title>See Also</title>

    <simplelist type="inline">
      <member><link linkend="gsort">gsort</link></member>

      <member><link linkend="unique">unique</link></member>
    </simplelist>
  </refsection>
</refentry>
